% A quick hack for making a latex table body
% from the statistics (torp_stat.pl)

table_style(texw).
field_width(9).

benchmark(fules2a).
benchmark(fules3).
benchmark(fules_clean).


benchmark_result(TC, Bm, TimeMsec/Btrk) :-
	stat(Bm,TC,_Date,Time,Btrk), TimeMsec is Time*1000.

simple_test_case(base         ).		 
simple_test_case(base_cs      ).
simple_test_case(base_cso     ).
simple_test_case(redund       ).
simple_test_case(max_dual     ).
simple_test_case(ships        ).
simple_test_case(filter_repet ).
simple_test_case(filter       ).
simple_test_case(rel_ind      ).
simple_test_case(diag_arith   ).
simple_test_case(diag_cond    ).

test_case(Name, Name) :-
	simple_test_case(Name).
test_case(no_count_empties, [-(count_empties),diag(ind_cond),
   relation(indexical),filter([on]),label(ships)]    ).

:- ensure_loaded(torp_stat).

tabulate :-
	(   test_case(Name, Id),
	    tab_one(Name, Id, user_output),
	    fail
	;   true
	).

tab_one(Name, Id, S) :-
	tex_start(S, Name),
	benchmark(Bm),
	(   benchmark_result(Id, Bm, TimeBtrk) -> tex_column(S, TimeBtrk)
	;   tex_empty(S)
	), fail.
tab_one(_, _, S) :-
	tex_end(S).

col_delimiters(tbl, '|', ' ').
col_delimiters(tex, '&', '&').
col_delimiters(texw, ' &', ' &').

line_delimiter(tbl, '').
line_delimiter(tex, '\\\\').
line_delimiter(texw, '\\\\').

tex_start(S, Id) :-
	format(S, '~|~w~t~27+', [Id]).

tex_empty(S) :-
	table_style(St),
	field_width(W), W1 is W+4, W2 is W,
	col_delimiters(St, Delim1, Delim2),
	format(S, '~|~a~t~a~*+~t~*+', [Delim1,Delim2,W1,W2]).

tex_column(S, Time/B) :-
	table_style(St),
	col_delimiters(St, Delim1, Delim2),
	field_width(W), W1 is W+4, W2 is W,
	format(S, '~|~a~t~3d~a~*+', [Delim1,Time,Delim2,W1]),
	(   B >= 100000 -> BK is integer(round(B/1000)),
	    format(S, '~|~t~wK~*+', [BK,W2])
	;   format(S, '~|~t~w~*+', [B,W2])
	).

tex_end(S) :-
	table_style(St),
	line_delimiter(St, LD),
	format(S, '~a~n', [LD]).


